更多导航首页资讯中心软件下载单机游戏手机应用源码下载驱动下载

资讯教程业界新闻 互联网 硬件数码 安全资讯 游戏资讯 游戏攻略 手机相关 软件报道

软件下载网络软件 系统工具 应用软件 联络聊天 图形图像 多媒体类 手机软件 游戏娱乐

单机游戏动作射击 策略战略 角色扮演 体育竞技 冒险解密 模拟养成 棋牌益智 其它游戏

手机应用iPhoneSymbianWP7PPCJAVA

源码下载ASP源码 PHP源码 CGI源码 JSP源码 .Net源码 VC/C++ VB源码 C#源码

硬件驱动驱动下载硬件工具

您的位置:首页新闻编程开发网络编程PHP编程

php抛出异常及捕捉特定类型异常解决办法

来源:维维整理作者:维维时间:2016-10-26 14:36:19我要评论(0)

php抛出异常及捕捉特定类型异常解决思路是什么?异常捕获在现在不少的ide工具中都能够用快捷键很方便的添加上,防止用户看到自己看不懂的报错甚至莫名其妙崩溃,导致用户体验不好。即使是显示一个友好一些的崩溃提示,也比直接显示error:xxxx xxxxxxxxx要好的多。今天给各位编程爱好者带来的是php如何抛出异常与捕捉特定类型的异常实例,有兴趣的朋友来详细了解一下吧。

什么是异常?

PHP5 提供了一种新的面向对象的错误处理办法。

异常处理用于在指定的错误(异常)情况发生的时候改变脚本的正常流程。这种情况称作异常。

当异常被触发时,通常会发生:

当前代码状态被保存

代码执行被切换到预定义的异常处理器函数

根据情况,处理器可能会从保存的代码状态重新开始执行代码,终止脚本执行,或者是从代码中另外的位置继续执行脚本

我们将会展示不同的错误处理方法:

异常的基本使用

创建自定义的异常处理器

多个异常

重新抛出异常

设置顶层异常处理器

php抛出异常与捕捉特定类型的异常最终的目的还是要给出对应的解决办法,让代码能够继续运行。

本文测试环境:PHP5.5.36  Safari 9.1.2

 1 <?php
 2 header("content-type:text/html; charset=utf-8");
 3 /**
 4 * 包裹重量异常
 5 */
 6 class HeavyParcelException extends Exception {}
 7
 8 /**
 9 * 包裹类
10 */
11 class Parcel {
12
13   /**
14   * 包裹寄送目的地地址
15   */
16   public $address;
17
18   /**
19   * 包裹重量
20   */
21   public $weight;
22 }
23
24 /**
25 * 派送员
26 */
27 class Courier {
28 
29   /**
30   * 运送
31   */
32   public function ship(Parcel $parcel) {
33     //check we have an address
34     //如果包裹的目的地为空
35     if(empty($parcel->address)) {
36 throw new Exception('address not Specified(未填写地址)!');
37     }
38
39     //check the weight
40     //如果重量超过5
41     if($parcel->weight > 5) {
42 throw new HeavyParcelException('Parcel exceeds courier limit(包裹超过运送上限)!');
43     }
44
45     //otherwise we're coll
46     return true;
47   }
48 }
49
50 $myCourier = new Courier();
51 $parcel = new Parcel();
52 //add the address if we have it 为了测试这里不填写地址
53 $parcel->weight = 7;
54 try {
55   $myCourier->ship($parcel);
56   echo "parcel shipped";
57 } catch (HeavyParcelException $e) {//捕获HeavyParcelException 不写这一个异常的类型名字,就跑到普通Exception抛出去了
58   echo "Parcel weight error(重量错误): " . $e->getMessage();
59   //redirect them to choose another courier
60 } catch (Exception $e) {
61   echo "Someting went wrong(地址错误): " . $e->getMessage();
62   //exit so we don't try to proceed any further
63   exit;
64 }
65 echo '<br/>';
66 $a = 123;
67 echo $a;

从54行开始的代码执行顺序:

55 >

32 >

35(ship方法中先检查的是地址为空,这里会抛出Exception,而不是57行的HeavyParcelException) >

60(捕获到Exception) >

616263 输出地址错误 exit;不会输出65到67行了

Tips:

本人认为这一块最重要的就是要搞清楚代码执行的顺序。写几段,然后改改跑跑。

1.捕获的顺序,要看try中的代码中throw的是哪个类型的Exception,之后才看 catch里的顺序。

2.57行的捕获的是特定的类型HeavyParcelException不可以写错,或者写Exception都会有问题。大家可以试一试。

1)比如地址不为空,57行写成了HeavyParcelException111,就会,在60行它的父类对象中捕获到,重量错误。这不是咱们想要的。

2)比如地址为空,57行写成了Exception,会抛出地址错误,不过捕获的却是本来负责重量的catch。这也不是咱们想要的。

[访问统计:]
上一篇:如何使用python分析access日志例子思路分享
下一篇:C#利用Shader实现夜幕降临倒计时效果例子分享

相关推荐

相关软件

文章评论
发表评论